# ifndef FDIO_H
# define FDIO_H

# include <HsFFI.h>

# include <sys/types.h>

int fdio_seek_cur(void);
int fdio_seek_set(void);
int fdio_seek_end(void);
int fdio_o_trunc(void);
int fdio_o_binary(void);
int fdio_o_nonblock(void);
int fdio_o_noctty(void);
int fdio_o_creat(void);
int fdio_o_rdonly(void);
int fdio_o_wronly(void);
int fdio_o_rdwr(void);
int fdio_o_append(void);
int fdio_o_excl(void);

void *fdio_new_wait_d(int fd, int msec, int is_socket);
void fdio_run_wait_d(void *d);
int fdio_wait_retval(void *d);
void fdio_delete_wait_d(void *d);

int fdio_ready(int fd, int msec, int is_socket);
off_t fdio_filesize(int fd);
int fdio_setecho(int fd, int set);
int fdio_getecho(int fd);
int fdio_sync(int fd);
unsigned fdio_getpid(void);

# if defined __GLASGOW_HASKELL__ && !defined mingw32_HOST_OS
int fdio_get_status_flags(int fd);
int fdio_set_status_flags(int fd, int flags);
# endif

off_t fdio_lseek(int fd, int whence, off_t offset);

int fdio_winsock_output_ready(int fd);

# endif
